#ifndef __GRAPHIX_H__
#define __GRAPHIX_H__

#include <cstdarg>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>
#include <SDL/SDL.h>

struct Texture{
	GLuint texture[1];
	GLuint mask[1];
	SDL_Surface* text[1];
	SDL_Surface* mas[1];
	int w,h;
	void free(){
		glDeleteTextures(1,texture);
		glDeleteTextures(1,mask);
		SDL_FreeSurface(text[0]);
		SDL_FreeSurface(mas[0]);
	}
};

class Graphix{
	private:
		int screen_width,screen_height,screen_bpp;
		int flags;
		bool full_screen,double_buffer;
		bool created;
		SDL_Surface *surface;
		GLuint base;
		vector<Texture> textures;
		SDL_Surface *background,*background2;
		GLuint gl_background,gl_background2;
		SDL_Surface *dirt;
	public:
		Graphix(int screen_width=1024,int screen_height=768,int screen_bpp=32,bool full_screen=false,bool double_buffer=true);
		~Graphix();
		int	load_graphix(string filename);
		int	free_graphix();
		int	initGL();
		int	resize_window(int width,int height);
		GLvoid	build_font(GLvoid);
		GLvoid	destroy_font(GLvoid);
		GLvoid	print(double x,double y,double r,double g,double b,const char *fmt,...);
		// na pracu s bitmapami
		void	flush_screen(int x1,int y1,int x2,int y2);
		void	draw_texture(int texture,int x,int y,int w=-1,int h=-1);
		void	clear_color(double r,double g,double b);
};

#endif
